#include <QtGui>
#include <QtGui/QApplication>
#include "wedesktopchanger.h"
#include <QDesktopWidget>
#include <QDir>
#include <QFile>
#include <QTextStream>
#include <QProcess>

QString desktopnumber;
void checkfiles()
{
	QString dbfile = "/var/tiitoo/pinnwand/pinnwand.db.sqlite";
	QString inifile = QDir::homePath()+"/.appdata/tiitoo-pinnwand/pinnwand.ini";
	if (QFile::exists(inifile)==false)
	{
	QFile f(inifile);
	if ( f.open(QIODevice::WriteOnly|QIODevice::Truncate|QIODevice::Text) )
	{
			QTextStream ts(&f);
			ts << "[General]" << desktopnumber << "\n";
			ts << "BackgroundImage=/usr/share/pixmaps/tiitoo/pinnwand/backgrounds/pinnwand-bg-02.png" << desktopnumber << "\n";
			f.close();
		}

	}	
	if (QFile::exists(inifile+"_1")==false)
	{
	QFile f(inifile+"_1");
	if ( f.open(QIODevice::WriteOnly|QIODevice::Truncate|QIODevice::Text) )
	{
			QTextStream ts(&f);
			ts << "[General]" << desktopnumber << "\n";
			ts << "BackgroundImage=/usr/share/pixmaps/tiitoo/pinnwand/backgrounds/pinnwand-bg-02.png" << desktopnumber << "\n";
			f.close();
		}

	}	
	if (QFile::exists(inifile+"_2")==false)
	{
	QFile f(inifile+"_2");
	if ( f.open(QIODevice::WriteOnly|QIODevice::Truncate|QIODevice::Text) )
	{
			QTextStream ts(&f);
			ts << "[General]" << desktopnumber << "\n";
			ts << "BackgroundImage=/usr/share/pixmaps/tiitoo/pinnwand/backgrounds/pinnwand-bg-02.png" << desktopnumber << "\n";
			f.close();
		}

	}	
	if (QFile::exists(inifile+"_3")==false)
	{
	QFile f(inifile+"_3");
	if ( f.open(QIODevice::WriteOnly|QIODevice::Truncate|QIODevice::Text) )
	{
			QTextStream ts(&f);
			ts << "[General]" << desktopnumber << "\n";
			ts << "BackgroundImage=/usr/share/pixmaps/tiitoo/pinnwand/backgrounds/pinnwand-bg-02.png" << desktopnumber << "\n";
			f.close();
		}

	}	
	if (QFile::exists(inifile+"_4")==false)
	{
	QFile f(inifile+"_4");
	if ( f.open(QIODevice::WriteOnly|QIODevice::Truncate|QIODevice::Text) )
	{
			QTextStream ts(&f);
			ts << "[General]" << desktopnumber << "\n";
			ts << "BackgroundImage=/usr/share/pixmaps/tiitoo/pinnwand/backgrounds/pinnwand-bg-02.png" << desktopnumber << "\n";
			f.close();
		}

	}	
	if (QFile::exists(inifile+"_5")==false)
	{
	QFile f(inifile+"_5");
	if ( f.open(QIODevice::WriteOnly|QIODevice::Truncate|QIODevice::Text) )
	{
			QTextStream ts(&f);
			ts << "[General]" << desktopnumber << "\n";
			ts << "BackgroundImage=/usr/share/pixmaps/tiitoo/pinnwand/backgrounds/pinnwand-bg-02.png" << desktopnumber << "\n";
			f.close();
		}

	}	
	if (QFile::exists(dbfile+"_origsave")==false)
		QFile::copy(dbfile,dbfile+"_origsave");
	if (QFile::exists(dbfile+"_1")==false)
		QFile::copy(dbfile,dbfile+"_1");
	if (QFile::exists(dbfile+"_2")==false)
		QFile::copy(dbfile,dbfile+"_2");
	if (QFile::exists(dbfile+"_3")==false)
		QFile::copy(dbfile,dbfile+"_3");
	if (QFile::exists(dbfile+"_4")==false)
		QFile::copy(dbfile,dbfile+"_4");
	if (QFile::exists(dbfile+"_5")==false)
		QFile::copy(dbfile,dbfile+"_5");


}

bool saveconfig()
{
	QString filename = QDir::homePath() + "/" + CONFIG_FILE;

	// save configuration to file
	QFile f(filename);

	if ( f.open(QIODevice::WriteOnly|QIODevice::Truncate|QIODevice::Text) )
	{
		QTextStream ts(&f);
		ts << "desktop = " << desktopnumber << "\n";
		f.close();
		return true;
	}

	printf("Kann Configdatei nicht speichern %s\n", filename.toUtf8().data());
	return false;
}

bool loadconfig()
{
	QString filename = QDir::homePath() + "/" + CONFIG_FILE;

	QFile f(filename);
	if ( f.open(QIODevice::ReadOnly|QIODevice::Text) )
	{
		QTextStream ts(&f);
		while ( !ts.atEnd() )
		{
			QString line = ts.readLine(1024);
			int k = line.indexOf("=");
			if ( k < 0 ) continue;
			QString key = line.mid(0,k).trimmed();
			QString value = line.mid(k+1).trimmed();

			if ( key == "desktop" )
				desktopnumber = value;

			// else => ignore unknown key
			f.close();
		}
		return true;
	}
	desktopnumber = "1";
	//printf("Config Datei konnte nicht geladen werden\n");
	return false;
}

void switch_to_1()
{
 //save actual desktop switch to 1
	QString dbfile = "/var/tiitoo/pinnwand/pinnwand.db.sqlite";
	QString inifile = QDir::homePath()+"/.appdata/tiitoo-pinnwand/pinnwand.ini";
	loadconfig();
	QFile::remove(dbfile+"_"+desktopnumber);
	QFile::copy(dbfile,dbfile+"_"+desktopnumber);
	QFile::remove(inifile+"_"+desktopnumber);
	QFile::copy(inifile,inifile+"_"+desktopnumber);
    desktopnumber = "1";
    saveconfig();
	QFile::remove(dbfile);
	QFile::copy(dbfile+"_"+desktopnumber,dbfile);
	QFile::remove(inifile);
	QFile::copy(inifile+"_"+desktopnumber,inifile);

	QProcess *proc = new QProcess();
	proc->start("killall tiitoo-pinnwand");
	proc->waitForFinished();
}
void switch_to_2()
{
 //save actual desktop switch to 2
	QString dbfile = "/var/tiitoo/pinnwand/pinnwand.db.sqlite";
	QString inifile = QDir::homePath()+"/.appdata/tiitoo-pinnwand/pinnwand.ini";
    loadconfig();
	QFile::remove(dbfile+"_"+desktopnumber);
	QFile::copy(dbfile,dbfile+"_"+desktopnumber);
	QFile::remove(inifile+"_"+desktopnumber);
	QFile::copy(inifile,inifile+"_"+desktopnumber);
    desktopnumber = "2";
    saveconfig();
	QFile::remove(dbfile);
	QFile::copy(dbfile+"_"+desktopnumber,dbfile);
	QFile::remove(inifile);
	QFile::copy(inifile+"_"+desktopnumber,inifile);
	QProcess *proc = new QProcess();
	proc->start("killall tiitoo-pinnwand");
	proc->waitForFinished();
}
void switch_to_3()
{
 //save actual desktop switch to 3
	QString dbfile = "/var/tiitoo/pinnwand/pinnwand.db.sqlite";
	QString inifile = QDir::homePath()+"/.appdata/tiitoo-pinnwand/pinnwand.ini";
    loadconfig();
	QFile::remove(dbfile+"_"+desktopnumber);
	QFile::copy(dbfile,dbfile+"_"+desktopnumber);
	QFile::remove(inifile+"_"+desktopnumber);
	QFile::copy(inifile,inifile+"_"+desktopnumber);
    desktopnumber = "3";
    saveconfig();
	QFile::remove(dbfile);
	QFile::copy(dbfile+"_"+desktopnumber,dbfile);
	QFile::remove(inifile);
	QFile::copy(inifile+"_"+desktopnumber,inifile);
	QProcess *proc = new QProcess();
	proc->start("killall tiitoo-pinnwand");
	proc->waitForFinished();
}
void switch_to_4()
{
 //save actual desktop switch to 4
	QString dbfile = "/var/tiitoo/pinnwand/pinnwand.db.sqlite";
	QString inifile = QDir::homePath()+"/.appdata/tiitoo-pinnwand/pinnwand.ini";
    loadconfig();
	QFile::remove(dbfile+"_"+desktopnumber);
	QFile::copy(dbfile,dbfile+"_"+desktopnumber);
	QFile::remove(inifile+"_"+desktopnumber);
	QFile::copy(inifile,inifile+"_"+desktopnumber);
    desktopnumber = "4";
    saveconfig();
	QFile::remove(dbfile);
	QFile::copy(dbfile+"_"+desktopnumber,dbfile);
	QFile::remove(inifile);
	QFile::copy(inifile+"_"+desktopnumber,inifile);
	QProcess *proc = new QProcess();
	proc->start("killall tiitoo-pinnwand");
	proc->waitForFinished();
}
void switch_to_5()
{
 //save actual desktop switch to 5
	QString dbfile = "/var/tiitoo/pinnwand/pinnwand.db.sqlite";
	QString inifile = QDir::homePath()+"/.appdata/tiitoo-pinnwand/pinnwand.ini";
    loadconfig();
	QFile::remove(dbfile+"_"+desktopnumber);
	QFile::copy(dbfile,dbfile+"_"+desktopnumber);
	QFile::remove(inifile+"_"+desktopnumber);
	QFile::copy(inifile,inifile+"_"+desktopnumber);
    desktopnumber = "5";
    saveconfig();
	QFile::remove(dbfile);
	QFile::copy(dbfile+"_"+desktopnumber,dbfile);
	QFile::remove(inifile);
	QFile::copy(inifile+"_"+desktopnumber,inifile);
	QProcess *proc = new QProcess();
	proc->start("killall tiitoo-pinnwand");
	proc->waitForFinished();
}

void print_console_help()
{
	printf("Usage: %s \n", "wedeskchanger" );
	printf("%-20s - %s\n", "1", "Switch to desktop 1");
	printf("%-20s - %s\n", "2", "Switch to desktop 2");
	printf("%-20s - %s\n", "3", "Switch to desktop 3");
	printf("%-20s - %s\n", "4", "Switch to desktop 4");
	printf("%-20s - %s\n", "5", "Switch to desktop 5");
	printf("%-20s - %s\n", "--version, -v", "show version");
	printf("%-20s - %s\n", "--help, -h", "this help");
}

void print_console_version( void )
{
	printf("wedesktopchanger\n");
	printf("Copyright (C) 2011 Peter Herzog www.pherzog.net\n");
	printf("Version %-6s\n", VERSION );
}

int main(int argc, char *argv[])
{
    QApplication a(argc, argv);
    checkfiles();
    QStringList args = a.arguments();
    for ( int i = 1; i < args.size(); i++ )
    {
	    QString v = args[i];
	    if ( v == "1" )
	    {
		    switch_to_1();
		    return 0;
	    }
	    else if ( v == "2" )
	    {
		    switch_to_2();
		    return 0;
	    }
	    else if ( v == "3"  )
	    {
		    switch_to_3();
		    return 0;
	    }
	    else if ( v == "4"  )
	    {
		    switch_to_4();
		    return 0;
	    }
	    else if ( v == "5"  )
	    {
		    switch_to_5();
		    return 0;
	    }
	    else if ( v == "--version" || v == "-v" ) {
		    print_console_version();
		    return 0;
	    }
	    else if ( v == "--help" || v == "-h" ) {
			print_console_help();
			return 0;
		}
    }
    wedesktopchanger w;
    w.setWindowTitle("Change Desktop #");
    w.show();
    return a.exec();
}
